import { SvelteComponentTyped } from "svelte";
import { type ComponentProps } from 'svelte';
import { PeriodType, type DisabledDate } from '@layerstack/utils';
import { type DateRange as DateRangeType } from '@layerstack/utils/dateRange';
import Dialog from './Dialog.svelte';
import Field from './Field.svelte';
declare const __propDef: {
    props: {
        [x: string]: any;
        value?: DateRangeType;
        stepper?: boolean | undefined;
        center?: boolean | undefined;
        periodTypes?: PeriodType[] | undefined;
        getPeriodTypePresets?: any;
        disabledDates?: DisabledDate | undefined;
        classes?: {
            field?: ComponentProps<Field>["classes"];
            dialog?: ComponentProps<Dialog>["classes"];
        } | undefined;
        label?: string | null | undefined;
        error?: string | undefined;
        hint?: string | undefined;
        disabled?: boolean | undefined;
        clearable?: boolean | undefined;
        base?: boolean | undefined;
        rounded?: boolean | undefined;
        dense?: boolean | undefined;
        icon?: string | null | undefined;
    };
    events: {
        change: CustomEvent<any>;
        clear: CustomEvent<any>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {
        prepend: {};
        append: {};
    };
};
export type DateRangeFieldProps = typeof __propDef.props;
export type DateRangeFieldEvents = typeof __propDef.events;
export type DateRangeFieldSlots = typeof __propDef.slots;
export default class DateRangeField extends SvelteComponentTyped<DateRangeFieldProps, DateRangeFieldEvents, DateRangeFieldSlots> {
}
export {};
