import { SvelteComponentTyped } from "svelte";
import { type PortalOptions } from '@layerstack/svelte-actions';
declare const __propDef: {
    props: {
        [x: string]: any;
        open?: boolean | undefined;
        portal?: PortalOptions | undefined;
        persistent?: boolean | undefined;
        loading?: boolean | null | undefined;
        classes?: {
            root?: string;
            dialog?: string;
            title?: string;
            actions?: string;
            backdrop?: string;
        } | undefined;
    };
    events: {
        introstart: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        outrostart: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        introend: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        outroend: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        close: CustomEvent<null>;
        closeAttempt: CustomEvent<null>;
        open: CustomEvent<null>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {
        header: {
            open: boolean;
            close: (options?: {
                force?: boolean;
            }) => void;
        };
        title: {
            open: boolean;
            close: (options?: {
                force?: boolean;
            }) => void;
        };
        default: {
            open: boolean;
            close: (options?: {
                force?: boolean;
            }) => void;
        };
        actions: {
            open: boolean;
            close: (options?: {
                force?: boolean;
            }) => void;
        };
    };
};
export type DialogProps = typeof __propDef.props;
export type DialogEvents = typeof __propDef.events;
export type DialogSlots = typeof __propDef.slots;
export default class Dialog extends SvelteComponentTyped<DialogProps, DialogEvents, DialogSlots> {
}
export {};
