import { SvelteComponentTyped } from "svelte";
import { type PortalOptions } from '@layerstack/svelte-actions';
declare const __propDef: {
    props: {
        [x: string]: any;
        open?: boolean | undefined;
        portal?: PortalOptions | undefined;
        persistent?: boolean | undefined;
        loading?: boolean | null | undefined;
        placement?: "top" | "bottom" | "left" | "right" | undefined;
        classes?: {
            root?: string;
            backdrop?: string;
            actions?: string;
        } | undefined;
    };
    events: {
        introstart: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        outrostart: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        introend: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        outroend: Event | KeyboardEvent | UIEvent | MouseEvent | FocusEvent | AnimationEvent | InputEvent | CompositionEvent | ClipboardEvent | DragEvent | ErrorEvent | FormDataEvent | PointerEvent | ProgressEvent<EventTarget> | SecurityPolicyViolationEvent | SubmitEvent | TouchEvent | TransitionEvent | WheelEvent;
        change: CustomEvent<{
            open: boolean;
        }>;
        close: CustomEvent<null>;
        closeAttempt: CustomEvent<null>;
        open: CustomEvent<null>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {
        default: {
            open: boolean;
            close: (options?: {
                force?: boolean;
            }) => void;
        };
        actions: {
            open: boolean;
            close: (options?: {
                force?: boolean;
            }) => void;
        };
    };
};
export type DrawerProps = typeof __propDef.props;
export type DrawerEvents = typeof __propDef.events;
export type DrawerSlots = typeof __propDef.slots;
export default class Drawer extends SvelteComponentTyped<DrawerProps, DrawerEvents, DrawerSlots> {
}
export {};
