import { SvelteComponentTyped } from "svelte";
import type { HTMLInputTypeAttribute } from 'svelte/elements';
import { type Actions } from '@layerstack/svelte-actions';
declare const __propDef: {
    props: {
        [x: string]: any;
        name?: string | undefined;
        value?: string | undefined;
        type?: HTMLInputTypeAttribute | undefined;
        inputmode?: "text" | "none" | "search" | "email" | "tel" | "url" | "numeric" | "decimal" | null | undefined;
        id?: string | undefined | undefined;
        actions?: Actions<HTMLInputElement | HTMLTextAreaElement> | undefined;
        inputEl?: (HTMLInputElement | HTMLTextAreaElement | null) | undefined;
        autocapitalize?: "none" | "characters" | "off" | "on" | "sentences" | "words" | null | undefined;
        class?: string | undefined | undefined;
        mask?: string | undefined;
        replace?: string | undefined;
        accept?: (string | RegExp) | undefined;
        placeholder?: string | undefined | undefined;
        required?: boolean | undefined;
        disabled?: boolean | undefined;
        min?: number | undefined | undefined;
        max?: number | undefined | undefined;
        step?: number | undefined | undefined;
    };
    events: {
        keydown: KeyboardEvent;
        keyup: KeyboardEvent;
        keypress: KeyboardEvent;
        input: Event;
        focus: FocusEvent;
        blur: CustomEvent<any>;
        change: CustomEvent<any>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {};
};
export type InputProps = typeof __propDef.props;
export type InputEvents = typeof __propDef.events;
export type InputSlots = typeof __propDef.slots;
export default class Input extends SvelteComponentTyped<InputProps, InputEvents, InputSlots> {
}
export {};
