import { SvelteComponentTyped } from "svelte";
import { type ComponentProps } from 'svelte';
import Field from './Field.svelte';
import MenuItem from './MenuItem.svelte';
import type { MenuOption } from '../types/index.js';
declare const __propDef: {
    props: {
        [x: string]: any;
        options?: MenuOption[] | undefined;
        value?: any;
        menuProps?: {
            [x: string]: any;
            open?: boolean | undefined;
            offset?: number | undefined;
            matchWidth?: boolean | undefined;
            placement?: import("@floating-ui/dom").Placement | undefined;
            autoPlacement?: boolean | undefined;
            resize?: boolean | "width" | "height" | undefined;
            disableTransition?: boolean | undefined;
            transition?: ((node: HTMLElement, params: import("../types/index.js").TransitionParams) => import("svelte/transition").TransitionConfig) | undefined | undefined;
            transitionParams?: import("../types/index.js").TransitionParams | undefined;
            explicitClose?: boolean | undefined;
            moveFocus?: boolean | undefined;
            classes?: {
                root?: string;
                menu?: string;
            } | undefined;
            menuItemsEl?: HTMLMenuElement | undefined;
        } | undefined;
        menuIcon?: string | undefined;
        stepper?: boolean | undefined;
        classes?: (ComponentProps<Field>["classes"] & {
            option?: string;
            menuItem?: ComponentProps<MenuItem>["classes"];
            menuIcon?: string;
            group?: string;
        }) | undefined;
        selected?: any;
    };
    events: {
        change: CustomEvent<{
            value: any;
            option: MenuOption;
        }>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {
        selection: {};
        prepend: {};
        append: {};
        default: {
            options: MenuOption[];
            selected: any;
            close: () => boolean;
            setValue: (val: any) => void;
        };
    };
};
export type MenuFieldProps = typeof __propDef.props;
export type MenuFieldEvents = typeof __propDef.events;
export type MenuFieldSlots = typeof __propDef.slots;
export default class MenuField extends SvelteComponentTyped<MenuFieldProps, MenuFieldEvents, MenuFieldSlots> {
}
export {};
