import { SvelteComponentTyped } from "svelte";
import type { OffsetOptions, Placement } from '@floating-ui/dom';
import { type PopoverOptions } from '@layerstack/svelte-actions';
declare const __propDef: {
    props: {
        open?: boolean;
        placement?: Placement | undefined;
        class?: string | undefined;
        style?: string | undefined;
        /**
           * Place popover based on which side of the viewport has more space
           */ autoPlacement?: boolean;
        /**
           * Provide element to anchor.  If not provided, uses direct parent of Popover
           */ anchorEl?: Element | HTMLElement | undefined;
        /**
           * Offset between anchor and popover
           */ offset?: OffsetOptions;
        /**
           * Shift popover if within threshold of window
           */ padding?: number;
        /**
           * Set width of popover element the same as anchor element
           */ matchWidth?: boolean;
        /**
           * Set max-height of popover element to the remaining height from anchor element to bottom of viewport
           */ resize?: PopoverOptions["resize"];
    };
    events: {
        close: CustomEvent<any>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {
        default: {
            close: () => void;
        };
    };
};
export type PopoverProps = typeof __propDef.props;
export type PopoverEvents = typeof __propDef.events;
export type PopoverSlots = typeof __propDef.slots;
export default class Popover extends SvelteComponentTyped<PopoverProps, PopoverEvents, PopoverSlots> {
}
export {};
