import { getSettings } from './settings.js';
export function getComponents() {
    return getSettings().components ?? {};
}
export function resolveComponentClasses(theme) {
    return typeof theme === 'string' ? { root: theme } : (theme ?? {});
}
/**
 * Returns default component classes for a given component. See {@link resolveComponentSettings}
 * to get both default props and classes.
 * @param name component name
 */
export function getComponentClasses(name) {
    const settings = getSettings();
    return resolveComponentClasses(settings?.components?.[name]?.classes);
}
